Subject: Re: [bisected] kernel panic 2.6.22 -> 2.6.26-rc9+

From: Willy Tarreau <[email-masked]>
Date: Wed, 23 Jul 2008 06:52:31 +0200

On Sun, Jul 13, 2008 at 02:55:25PM -0700, Andrew Morton wrote:
> On Sun, 13 Jul 2008 23:51:06 +0200 Krzysztof Halasa <[email-masked]> wrote:
> 
> > Andrew Morton <[email-masked]> writes:
> > 
> > > --- a/include/asm-arm/bitops.h~a
> > > +++ a/include/asm-arm/bitops.h
> > > @@ -277,9 +277,16 @@ static inline int constant_fls(int x)
> > >   * the clz instruction for much better code efficiency.
> > >   */
> > >  
> > > -#define fls(x) \
> > > +#define __fls(x) \
> > >  	( __builtin_constant_p(x) ? constant_fls(x) : \
> > >  	  ({ int __r; asm("clz\t%0, %1" : "=r"(__r) : "r"(x) : "cc"); 32-__r; }) )
> > > +
> > > +/* Implement fls() in C so that 64-bit args are suitably truncated */
> > > +static inline int fls(int x)
> > > +{
> > > +	return __fls(x);
> > > +}
> > > +
> > 
> > Well, I like it more as it fixes all possible places instead of only
> > fls64().
> > 
> > But... can't we just move the #define body into the inline fls(x)?
> > Will there be other users of __fls(x)? It seems the
> > __builtin_constant_p(x) works for inline functions.
> 
> Could.  That was a minimal&safe thing.
> 
> > The above patch fixes the kernel panic, too.
> 
> OK, thanks.

Andrew,

have you sent your patch to Linus ? I haven't seen it merged yet, and
I'd like to get it into -stable too.

Thanks,
Willy